import { createShippoConfiguration as publicCreateShippoConfiguration, getShippoConfiguration as publicGetShippoConfiguration, updateShippoConfiguration as publicUpdateShippoConfiguration, deleteShippoConfiguration as publicDeleteShippoConfiguration, queryShippoConfigurations as publicQueryShippoConfigurations, updateExtendedFields as publicUpdateExtendedFields, addDeliveryRegion as publicAddDeliveryRegion, removeDeliveryRegion as publicRemoveDeliveryRegion } from './ecom-v1-shippo-configuration-shippo-configurations.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onShippoConfigurationCreated as publicOnShippoConfigurationCreated } from './ecom-v1-shippo-configuration-shippo-configurations.public.js';
import { onShippoConfigurationDeleted as publicOnShippoConfigurationDeleted } from './ecom-v1-shippo-configuration-shippo-configurations.public.js';
import { onShippoConfigurationUpdated as publicOnShippoConfigurationUpdated } from './ecom-v1-shippo-configuration-shippo-configurations.public.js';
export declare const createShippoConfiguration: MaybeContext<BuildRESTFunction<typeof publicCreateShippoConfiguration> & typeof publicCreateShippoConfiguration>;
export declare const getShippoConfiguration: MaybeContext<BuildRESTFunction<typeof publicGetShippoConfiguration> & typeof publicGetShippoConfiguration>;
export declare const updateShippoConfiguration: MaybeContext<BuildRESTFunction<typeof publicUpdateShippoConfiguration> & typeof publicUpdateShippoConfiguration>;
export declare const deleteShippoConfiguration: MaybeContext<BuildRESTFunction<typeof publicDeleteShippoConfiguration> & typeof publicDeleteShippoConfiguration>;
export declare const queryShippoConfigurations: MaybeContext<BuildRESTFunction<typeof publicQueryShippoConfigurations> & typeof publicQueryShippoConfigurations>;
export declare const updateExtendedFields: MaybeContext<BuildRESTFunction<typeof publicUpdateExtendedFields> & typeof publicUpdateExtendedFields>;
export declare const addDeliveryRegion: MaybeContext<BuildRESTFunction<typeof publicAddDeliveryRegion> & typeof publicAddDeliveryRegion>;
export declare const removeDeliveryRegion: MaybeContext<BuildRESTFunction<typeof publicRemoveDeliveryRegion> & typeof publicRemoveDeliveryRegion>;
/**
 * Triggered when a shipping option is created.
 */
export declare const onShippoConfigurationCreated: ReturnType<typeof createEventModule<typeof publicOnShippoConfigurationCreated>>;
/**
 * Triggered when a shipping option is deleted.
 */
export declare const onShippoConfigurationDeleted: ReturnType<typeof createEventModule<typeof publicOnShippoConfigurationDeleted>>;
/**
 * Triggered when a shipping option is updated.
 */
export declare const onShippoConfigurationUpdated: ReturnType<typeof createEventModule<typeof publicOnShippoConfigurationUpdated>>;
export { DomesticService, CalculationType, InternationalService, PackageType, SortOrder, WebhookIdentityType, } from './ecom-v1-shippo-configuration-shippo-configurations.universal.js';
export { ShippoConfiguration, DomesticServiceSettings, ServiceSettings, HandlingFee, InternationalServiceSettings, PackageDetails, PackageDimensions, Address, StreetAddress, AddressLocation, ExtendedFields, CreateShippoConfigurationRequest, CreateShippoConfigurationResponse, GetShippoConfigurationRequest, GetShippoConfigurationResponse, UpdateShippoConfigurationRequest, UpdateShippoConfigurationResponse, DeleteShippoConfigurationRequest, DeleteShippoConfigurationResponse, QueryShippoConfigurationsRequest, CursorQuery, CursorQueryPagingMethodOneOf, Sorting, CursorPaging, QueryShippoConfigurationsResponse, CursorPagingMetadata, Cursors, UpdateExtendedFieldsRequest, UpdateExtendedFieldsResponse, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, Empty, AddDeliveryRegionRequest, AddDeliveryRegionResponse, RemoveDeliveryRegionRequest, RemoveDeliveryRegionResponse, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, EventMetadata, ShippoConfigurationCreatedEnvelope, ShippoConfigurationDeletedEnvelope, ShippoConfigurationUpdatedEnvelope, CreateShippoConfigurationOptions, UpdateShippoConfiguration, ShippoConfigurationsQueryResult, ShippoConfigurationsQueryBuilder, UpdateExtendedFieldsOptions, AddDeliveryRegionOptions, RemoveDeliveryRegionIdentifiers, RemoveDeliveryRegionOptions, } from './ecom-v1-shippo-configuration-shippo-configurations.universal.js';
