import { RequestOptionsFactory } from '@wix/sdk-types';
/** Creates a ShippoConfiguration. */
export declare function createShippoConfiguration(payload: object): RequestOptionsFactory<any>;
/** Retrieves a ShippoConfiguration. */
export declare function getShippoConfiguration(payload: object): RequestOptionsFactory<any>;
/** Updates a ShippoConfiguration. */
export declare function updateShippoConfiguration(payload: object): RequestOptionsFactory<any>;
/** Deletes a ShippoConfiguration. */
export declare function deleteShippoConfiguration(payload: object): RequestOptionsFactory<any>;
/**
 * Retrieves a list of ShippoConfigurations, given the provided [paging, filtering, and sorting][1].
 *
 * Up to 1,000 ShippoConfigurations can be returned per request.
 *
 * To learn how to query ShippoConfigurations, see [API Query Language][2].
 *
 * [1]: https://dev.wix.com/api/rest/getting-started/sorting-and-paging
 * [2]: https://dev.wix.com/api/rest/getting-started/api-query-language
 */
export declare function queryShippoConfigurations(payload: object): RequestOptionsFactory<any>;
/** Updates extended fields of a ShippoConfiguration without incrementing revision */
export declare function updateExtendedFields(payload: object): RequestOptionsFactory<any>;
/** Adds a delivery region to a Shippo configuration. */
export declare function addDeliveryRegion(payload: object): RequestOptionsFactory<any>;
/**
 * Removes a delivery region from a Shippo configuration.
 * When passing the ID of the only existing delivery region, removing it will delete the Shippo configuration.
 */
export declare function removeDeliveryRegion(payload: object): RequestOptionsFactory<any>;
